#include <iostream>
#include <vector>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int bin[31];
    bin[0]=1;
    for(int i=1;i<31;i++)
    {
        bin[i]=bin[i-1]*2;
    }
    int n;
    cin >>n;
    vector<int> kecevi(31,0);
    vector<int> v(n);
    for(int i=0;i<n;i++)
    {
        cin >>v[i];
        for(int j=0;j<31;j++)
        {
            if(v[i]&bin[j])
            {
                kecevi[j]++;
            }
        }
    }
    int m;
    cin >>m;
    for(int i=0;i<m;i++)
    {
        int t;
        cin >>t;
        if(t==0)
        {
            int k;
            cin >>k;
            int rez=0;
            for(int j=0;j<31;j++)
            {
                if(kecevi[j]>=k)
                {
                    rez+=bin[j];
                }
            }
            cout <<rez<<"\n";
        }
        else
        {
            int k,x;
            cin >>k>>x;
            k--;
            for(int j=0;j<31;j++)
            {
                if(v[k]&bin[j])
                {
                    kecevi[j]--;
                }
                if(x&bin[j])
                {
                    kecevi[j]++;
                }
            }
            v[k]=x;
        }
    }


    return 0;
}